
Redmine - Defect #16645

undefined method `>' for nil:NilClass

2014-04-12 01:42 - Alexander Klevtsov

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Custom fields Estimated time: 0.00 hour

Target version:    

Resolution: Cant reproduce Affected version: 2.4.5

Description

After upgrade from 2.4-dev to 2.4.5 started in some projects encounter errors:

undefined method `>' for nil:NilClass

  [1m[35m (0.1ms)[0m  SELECT MAX(`settings`.`updated_on`) AS max_id FROM `settings` 

  [1m[36mUser Load (0.1ms)[0m  [1mSELECT `users`.* FROM `users` WHERE `users`.`type` IN ('User', '

AnonymousUser') AND `users`.`status` = 1 AND `users`.`id` = 1 LIMIT 1[0m

  Current user: kaa (id=1)

  [1m[35mProject Load (0.1ms)[0m  SELECT `projects`.* FROM `projects` WHERE `projects`.`identifier

` = 'olis-lxg-travel' LIMIT 1

  [1m[36mSQL (0.1ms)[0m  [1mSELECT `enabled_modules`.`name` FROM `enabled_modules` WHERE `enabled_

modules`.`project_id` = 39[0m

  [1m[35mIssueStatus Load (0.1ms)[0m  SELECT `issue_statuses`.* FROM `issue_statuses` WHERE `issue

_statuses`.`is_default` = 1 LIMIT 1

  [1m[36mCACHE (0.0ms)[0m  [1mSELECT `issue_statuses`.* FROM `issue_statuses` WHERE `issue_statuse

s`.`is_default` = 1 LIMIT 1[0m

  [1m[35mIssuePriority Load (0.1ms)[0m  SELECT `enumerations`.* FROM `enumerations` WHERE `enumera

tions`.`type` IN ('IssuePriority') AND `enumerations`.`is_default` = 1 ORDER BY enumerations.posit

ion ASC LIMIT 1

  [1m[36mProject Load (0.1ms)[0m  [1mSELECT `projects`.* FROM `projects` WHERE `projects`.`id` = 3

9 LIMIT 1[0m

  [1m[35mTracker Load (0.2ms)[0m  SELECT `trackers`.* FROM `trackers` INNER JOIN `projects_tracker

s` ON `trackers`.`id` = `projects_trackers`.`tracker_id` WHERE `projects_trackers`.`project_id` = 

39 AND `trackers`.`id` = 1 ORDER BY trackers.position LIMIT 1

  [1m[36mCACHE (0.0ms)[0m  [1mSELECT `issue_statuses`.* FROM `issue_statuses` WHERE `issue_statuse

s`.`is_default` = 1 LIMIT 1[0m

  [1m[35mRole Load (0.1ms)[0m  SELECT `roles`.* FROM `roles` 

  [1m[36mWorkflowTransition Load (0.1ms)[0m  [1mSELECT `workflows`.* FROM `workflows` WHERE `workf

lows`.`type` IN ('WorkflowTransition') AND `workflows`.`old_status_id` = 1 AND (role_id IN (1,2,3,

4,5,6,7,8) AND tracker_id = 1 AND ((author = 0 AND assignee = 0) OR author = 1))[0m

  [1m[35mIssueStatus Load (0.1ms)[0m  SELECT `issue_statuses`.* FROM `issue_statuses` WHERE `issue

_statuses`.`id` IN (5, 4, 3, 2, 6)

  [1m[36mSQL (0.1ms)[0m  [1mSELECT `enabled_modules`.`name` FROM `enabled_modules` WHERE `enabled_

modules`.`project_id` = 39[0m

  [1m[35mCACHE (0.0ms)[0m  SELECT `roles`.* FROM `roles` 

  [1m[36mWorkflowPermission Load (0.1ms)[0m  [1mSELECT `workflows`.* FROM `workflows` WHERE `workf

lows`.`type` IN ('WorkflowPermission') AND `workflows`.`tracker_id` = 1 AND `workflows`.`old_statu

s_id` = 1 AND `workflows`.`role_id` IN (1, 2, 3, 4, 5, 6, 7, 8)[0m

  [1m[35mTracker Load (0.2ms)[0m  SELECT `trackers`.* FROM `trackers` WHERE `trackers`.`id` = 1 LI

MIT 1

  [1m[36mCACHE (0.0ms)[0m  [1mSELECT `roles`.* FROM `roles` [0m

  [1m[35mCACHE (0.0ms)[0m  SELECT `workflows`.* FROM `workflows` WHERE `workflows`.`type` IN ('Wor

kflowPermission') AND `workflows`.`tracker_id` = 1 AND `workflows`.`old_status_id` = 1 AND `workfl

ows`.`role_id` IN (1, 2, 3, 4, 5, 6, 7, 8)

  [1m[36mCACHE (0.0ms)[0m  [1mSELECT `issue_statuses`.* FROM `issue_statuses` WHERE `issue_statuse

s`.`is_default` = 1 LIMIT 1[0m

  [1m[35mCACHE (0.0ms)[0m  SELECT `roles`.* FROM `roles` 

  [1m[36mCACHE (0.0ms)[0m  [1mSELECT `workflows`.* FROM `workflows` WHERE `workflows`.`type` IN ('

WorkflowTransition') AND `workflows`.`old_status_id` = 1 AND (role_id IN (1,2,3,4,5,6,7,8) AND tra

cker_id = 1 AND ((author = 0 AND assignee = 0) OR author = 1))[0m

  [1m[35mCACHE (0.0ms)[0m  SELECT `issue_statuses`.* FROM `issue_statuses` WHERE `issue_statuses`.

`id` IN (5, 4, 3, 2, 6)
  [1m[36mCACHE (0.0ms)[0m  [1mSELECT `issue_statuses`.* FROM `issue_statuses` WHERE `issue_statuse

s`.`is_default` = 1 LIMIT 1[0m

  [1m[35mCACHE (0.0ms)[0m  SELECT `roles`.* FROM `roles` 

  [1m[36mCACHE (0.0ms)[0m  [1mSELECT `workflows`.* FROM `workflows` WHERE `workflows`.`type` IN ('

WorkflowTransition') AND `workflows`.`old_status_id` = 1 AND (role_id IN (1,2,3,4,5,6,7,8) AND tra

cker_id = 1 AND ((author = 0 AND assignee = 0) OR author = 1))[0m

  [1m[35mCACHE (0.0ms)[0m  SELECT `issue_statuses`.* FROM `issue_statuses` WHERE `issue_statuses`.

`id` IN (5, 4, 3, 2, 6)

  [1m[36mCACHE (0.0ms)[0m  [1mSELECT `roles`.* FROM `roles` [0m

  [1m[35mCACHE (0.0ms)[0m  SELECT `workflows`.* FROM `workflows` WHERE `workflows`.`type` IN ('Wor

kflowPermission') AND `workflows`.`tracker_id` = 1 AND `workflows`.`old_status_id` = 1 AND `workfl

ows`.`role_id` IN (1, 2, 3, 4, 5, 6, 7, 8)

  [1m[36mIssueCustomField Load (0.2ms)[0m  [1mSELECT `custom_fields`.* FROM `custom_fields` INNER 

JOIN `custom_fields_trackers` ON `custom_fields`.`id` = `custom_fields_trackers`.`custom_field_id`

 WHERE `custom_fields`.`type` IN ('IssueCustomField') AND `custom_fields_trackers`.`tracker_id` = 

1[0m

  [1m[35mIssueCustomField Load (0.1ms)[0m  SELECT `custom_fields`.* FROM `custom_fields` WHERE `cu

stom_fields`.`type` IN ('IssueCustomField') AND (is_for_all = 1 OR id IN (SELECT DISTINCT cfp.cust

om_field_id FROM custom_fields_projects cfp WHERE cfp.project_id = 39)) ORDER BY custom_fields.pos

ition ASC

  [1m[36mCACHE (0.0ms)[0m  [1mSELECT `roles`.* FROM `roles` [0m

  [1m[35mCACHE (0.0ms)[0m  SELECT `workflows`.* FROM `workflows` WHERE `workflows`.`type` IN ('Wor

kflowPermission') AND `workflows`.`tracker_id` = 1 AND `workflows`.`old_status_id` = 1 AND `workfl

ows`.`role_id` IN (1, 2, 3, 4, 5, 6, 7, 8)

  [1m[36mCACHE (0.0ms)[0m  [1mSELECT `roles`.* FROM `roles` [0m

  [1m[35mCACHE (0.0ms)[0m  SELECT `workflows`.* FROM `workflows` WHERE `workflows`.`type` IN ('Wor

kflowPermission') AND `workflows`.`tracker_id` = 1 AND `workflows`.`old_status_id` = 1 AND `workfl

ows`.`role_id` IN (1, 2, 3, 4, 5, 6, 7, 8)

  [1m[36mCACHE (0.0ms)[0m  [1mSELECT `issue_statuses`.* FROM `issue_statuses` WHERE `issue_statuse

s`.`is_default` = 1 LIMIT 1[0m

  [1m[35mCACHE (0.0ms)[0m  SELECT `roles`.* FROM `roles` 

  [1m[36mCACHE (0.0ms)[0m  [1mSELECT `workflows`.* FROM `workflows` WHERE `workflows`.`type` IN ('

WorkflowTransition') AND `workflows`.`old_status_id` = 1 AND (role_id IN (1,2,3,4,5,6,7,8) AND tra

cker_id = 1 AND ((author = 0 AND assignee = 0) OR author = 1))[0m

  [1m[35mCACHE (0.0ms)[0m  SELECT `issue_statuses`.* FROM `issue_statuses` WHERE `issue_statuses`.

`id` IN (5, 4, 3, 2, 6)

  [1m[36mCACHE (0.0ms)[0m  [1mSELECT `issue_statuses`.* FROM `issue_statuses` WHERE `issue_statuse

s`.`is_default` = 1 LIMIT 1[0m

  [1m[35mUser Load (0.2ms)[0m  SELECT DISTINCT `users`.* FROM `users` INNER JOIN `members` ON `mem

bers`.`user_id` = `users`.`id` WHERE `users`.`type` IN ('User', 'AnonymousUser') AND `users`.`stat

us` = 1 AND (members.project_id = 39)

  [1m[36m (0.1ms)[0m  [1mBEGIN[0m

  [1m[35m (0.0ms)[0m  ROLLBACK

Completed 500 Internal Server Error in 273.3ms

NoMethodError (undefined method `>' for nil:NilClass):

  app/models/custom_field.rb:355:in `validate_field_value_format'

  app/models/custom_field.rb:334:in `validate_field_value'

  app/models/custom_field_value.rb:46:in `validate_value'

  lib/plugins/acts_as_customizable/lib/acts_as_customizable.rb:126:in `each'

  lib/plugins/acts_as_customizable/lib/acts_as_customizable.rb:126:in `validate_custom_field_value

s'

  app/controllers/issues_controller.rb:146:in `create'

 
Environment:

  Redmine version                2.4.5.stable

  Ruby version                   2.0.0-p451 (2014-02-24) [i686-linux]

  Rails version                  3.2.17

  Environment                    development

  Database adapter               Mysql2

SCM:

  Subversion                     1.6.12

  Cvs                            1.12.13

  Git                            1.7.2.5

  Filesystem                     

Redmine plugins:

  recaptcha                      1.0.0
  redmine_agile                  1.1.2-light

  redmine_people                 0.1.8

  redmine_questions              0.0.5

History

#1 - 2014-04-12 05:39 - Toshi MARUYAMA

- Status changed from New to Closed

- Resolution set to Cant reproduce

Please contact plugin author.

It seems one of your plugins overrides CustomField#validate_field_value_format or sets min_length null.

#2 - 2014-06-18 11:32 - Johan Guilbaud

I got same error as above but i don't have same plugin or plugin redefining this method

Environment:

  Redmine version                2.4.2.stable (with some official patches)

  Ruby version                   2.1.0-p0 (2013-12-25) [x86_64-linux]

  Rails version                  3.2.16

  Environment                    production

  Database adapter               Mysql2

SCM:

  Subversion                     1.8.8

  Filesystem                     

Redmine plugins:

  redmine_charts2                0.2.1

  redmine_wiki_unc               0.0.3

#3 - 2014-06-18 11:38 - Alexander Klevtsov

Update your redmine to last 2.5 version.

Error was at some migration database scripts.
